//
//  CategoryDetailViewController.swift
//  xsea
//
//  Created Phạm Anh Tuấn on 8/31/19.
//  Copyright © 2019 Phạm Anh Tuấn. All rights reserved.
//
//  Template generated by Juanpe Catalán @JuanpeCMiOS
//

import UIKit

class CategoryDetailViewController: UIViewController, CategoryDetailViewProtocol{
    
    
    @IBOutlet weak var productCollectionView: UICollectionView!
    
    func showCategoryDetails() {
        presenter?.products?.forEach({ (e) in
            print(e)
        })
        
        DispatchQueue.main.async {
            self.loader.isLunching = false
        }
    }
    

    private let loader = LoaderSettings()
	var presenter: CategoryDetailPresenterProtocol?

	override func viewDidLoad() {
        super.viewDidLoad()
        self.setupViews()
        loader.isLunching = true
        presenter?.getProductsOfCategory()
    }

}

extension CategoryDetailViewController{
    private func setupViews(){
        self.setupNavigationBar()
        self.view.backgroundColor = UIColor.white
        setupProductCollectionView()
    }
    
    private func setupNavigationBar(){
        self.navigationController?.navigationBar.isHidden = false
//        self.navigationItem.title = presenter?.category.name
        self.navigationItem.title =  "fafdsafas"
        self.navigationController?.navigationBar.prefersLargeTitles = true
        self.navigationController?.navigationBar.barTintColor = presenter?.navigationBarColor
        self.navigationController?.navigationBar.tintColor = UIColor.white
        self.navigationController?.navigationBar.largeTitleTextAttributes = [.foregroundColor: UIColor.white]
        self.navigationController?.view.backgroundColor = .clear
    }
}

extension CategoryDetailViewController: UICollectionViewDataSource, UICollectionViewDelegate, UICollectionViewDelegateFlowLayout{
    
    private func setupProductCollectionView(){
        productCollectionView.dataSource = self
        productCollectionView.delegate = self
        productCollectionView.register(UICollectionViewCell.self, forCellWithReuseIdentifier: "cellId")
    }
    func collectionView(_ collectionView: UICollectionView, numberOfItemsInSection section: Int) -> Int {
        return 100
    }
    
    func collectionView(_ collectionView: UICollectionView, cellForItemAt indexPath: IndexPath) -> UICollectionViewCell {
        let cell = collectionView.dequeueReusableCell(withReuseIdentifier: "cellId", for: indexPath)
        cell.backgroundColor = UIColor.red
        return cell
    }
    
    func collectionView(_ collectionView: UICollectionView, layout collectionViewLayout: UICollectionViewLayout, sizeForItemAt indexPath: IndexPath) -> CGSize {
        return CGSize(width: collectionView.frame.width, height: 200)
    }
}
